
//** Библиотека ***************************
function toJson(data) {
  try {
    return JSON.parse(data);
  }
  catch (e) {
  }

  return false;
}

function processResponse(data, msgError, reject, callbackSuccess) {
  app.preloader.hide();
  var res = toJson(data);

  if (res === false) {
    app.dialog.alert(msgError, 'Внимание!');
    reject();
    return;
  }

  if (!res.success) {
    var msg = res.result.error ? res.result.error : msgError;
    app.dialog.alert(msg, 'Внимание!');
    reject();
  }
  else {
    callbackSuccess(res);
  }
}

function isConnect() {
  if(navigator.connection.type == Connection.NONE) {
    app.dialog.alert('Для работы приложения необходимо интернет соединение', 'Внимание!');
    return false;
  }

  return true;
}
//** END Библиотека ***************************


//** Инициализация ***************************
var
  $$ = Dom7,
  domain = 'https://xn----7sbgza7acqhge3n.xn--p1ai',
  regNum = /^([а-яa-z])([0-9]{3})([а-яa-z]{2})([0-9]{2,3})$/i,
  regVin = /^[0-9a-zа-я]{17}$/i,
  regBn = /^[0-9a-zа-я_-]{4,17}$/i,
  regEmail = /^(?:[a-zA-Z0-9_-]+\.)*[a-z0-9_-]+@[a-z0-9_-]+(?:\.[a-z0-9_-]+)*\.[a-z]{2,6}$/i,
  appData = {}
;

// Framework7 App main instance
var app = new Framework7({
  root: '#app', // App root element
  id: 'com.aissoft.autoraport', // App bundle ID
  name: 'СтопПерекуп', // App name
  version: '2.3.0',
  theme: 'md',

  initOnDeviceReady: true,
  routes: routes,

  // Enable panel left visibility breakpoint
  panel: {
    leftBreakpoint: 960
    // swipe: 'left'
  }
});

app.on('init', function () {
  appData = {
    token: 'eV5cxX9FFN5Gsdnmr5gVjXA1FG92scfBZVM1LSzxPjc6ezvJc1zjDwrKhyKRPj7l',
    app_version: 1,
    device_version: device.version,
    uuid: device.uuid
  };

  //** Под ios это удалить *****************
  // var androidVersion = device.version.replace(/\./g, '').substr(0, 2);

  // if(androidVersion <= 42) {
  //   app.dialog.create({
  //     title: 'Внимание!',
  //     text: 'Ваше устройство не поддерживается'
  //   }).open();
  // }
  //** END Под ios это удалить *****************
});

var leftView = app.views.create('.view-left', {
  url: '/'
});

var mainView = app.views.create('.view-main', {
  url: '/'
});
//** END Инициализация ***************************


//** Основные табы ***************************
$$(document).on('click', '.button-select', function (e) {
  e.preventDefault();
  var $tabs = $$('.button-select');
  var $this = $$(this);
  var $input = $$('#my-main-input');

  $tabs.removeClass('active');
  $$('[data-select="'+ $this.data('select') +'"]').addClass('active');
  $input
    .attr('placeholder', $this.data('input'))
    .val('')
  ;
});

$$(document).on('click', '.main-button', function (e) {
  e.preventDefault();

  var select = $$('.button-select.active').data('select');
  var value = $$('#my-main-input').val();

  if(select === 'num' && ! regNum.test(value)) {
    app.dialog.alert('Гос. номер введён не верно', 'Внимание!');
    return;
  }
  else if(select === 'vin' && ! regVin.test(value)) {
    app.dialog.alert('VIN введён не верно', 'Внимание!');
    return;
  }
  else if(select === 'bn' && ! regBn.test(value)) {
    app.dialog.alert('Номер кузова введён не верно', 'Внимание!');
    return;
  }

  mainView.router.navigate('/report/');
});


// Удалим пробелы из пользовательского ввода
$$(document).on('input', '#my-main-input', function (e) {
  e.preventDefault();

  var
    $this = $$(this),
    val = $this.val(),
    reg = /\s|-/ig
  ;

  if(reg.test(val))
    val = val.replace(reg, '');

  $this.val(val.toUpperCase());
});
//** END Основные табы ***************************


//** Отправка обратной связи ***************************
$$(document).on('click', '.button-contacts-send', function (e) {
  e.preventDefault();

  var
    $name = $$('#name'),
    $email = $$('#email'),
    $msg = $$('#msg'),
    errors = []
  ;

  if( ! $name.val() || $name.val().length > 100)
    errors.push($name.data('err'));

  if( ! regEmail.test($email.val()))
    errors.push($email.data('err'));

  if( ! $msg.val() || $msg.val().length > 2000)
    errors.push($msg.data('err'));

  if(errors.join('')) {
    app.dialog.alert(errors.join('<br>'), 'Некорректен ввод!');
    return;
  }

  mainView.router.navigate('/contacts_send/');
});

$$(document).on('page:init', '.page[data-name="contacts"]', function(e) {
  setTimeout(function() { $$('#msg').val(''); }, 0);
});
//** END Отправка обратной связи ***************************


$$(document).on('page:init', '.page:not([data-name="page-report"])', function(e) {
  $$(document).find('.fixed-block-pay').remove();
});

$$(document).on('page:init', '.page[data-name="page-report"]', function(e) {
  $$(this).append($$('.fixed-block-pay'));
});


//** Обработка кнопок оплаты ***************************
var actionPay = app.actions.create({
  buttons: [
    [
      {
        text: 'Выберите способ оплаты',
        label: true
      },
      {
        text: 'Банковские карты',
        onClick: function () {
          handlerPay(2, 1);
        }
      },
      {
        text: 'Яндекс деньги',
        onClick: function () {
          handlerPay(2, 2);
        }
      },
      {
        text: 'Qiwi кошелёк',
        onClick: function () {
          handlerPay(2, 3);
        }
      },
      {
        text: 'МТС',
        onClick: function () {
          handlerPay(1, 2);
        }
      },
      {
        text: 'Билайн',
        onClick: function () {
          handlerPay(1, 4);
        }
      },
      {
        text: 'Теле2',
        onClick: function () {
          handlerPay(1, 5);
        }
      },
      {
        text: 'Samsung Pay',
        onClick: function () {
          handlerPay(1, 6);
        }
      }
    ],
    [
      {
        text: 'Отмена',
        bold: true
      }
    ]
  ]
});

$$(document).on('click', '.button-pay', function (e) {
  e.preventDefault();
  actionPay.open();
});

function handlerPay(shop, method) {
  var uid = $$('.button-pay').data('uid');
  mainView.router.navigate('/pay/'+ shop +'/'+ method +'/'+ uid +'/');
}
//** END Обработка кнопок оплаты ***************************


//** Обновление, загрузка страницы заказов ***************************
$$(document).on('click', '.my-orders-reload', function (e) {
  e.preventDefault();
  mainView.router.refreshPage();
});

$$(document).on('click', '.orders-action', function (e) {
  e.preventDefault();
  app.panel.close();
  if (mainView.router.currentRoute.url == '/orders/') {
    mainView.router.refreshPage();
  }
  else {
    mainView.router.navigate('/orders/');
  }
});
//** END Обновление, загрузка страницы заказов ***************************


//** Бесконечный скролл на заказах ***************************
var wait = false;
$$(document).on('infinite', '.infinite-scroll-orders', function () {

  if (wait) return;
  wait = true;

  var
    offset = $$('.ordersList li.my-item-list').length,
    data = app.utils.extend({offset: offset}, appData)
  ;

  app.request.post(domain + '/app/orders', data,
    function(data, status, xr) {
      if( ! isConnect()) { wait = false; return; }

      processResponse(data, 'Ошибка заказов', function(){ wait = false; }, function(res) {

        if(res.result.orders) {
          for(var i = 0; i < res.result.orders.length; i += 1) {
            var order = res.result.orders[i];
            res.result.orders[i].list = compiledTmpOrder(order);
          }

          var html = compiledTemplateOrders(res.result);
          $$('.ordersList').append(html);
        }

        if($$('.ordersList li.my-item-list').length >= res.result.max_items) {
          // app.dialog.alert('Заказов нет', 'Внимание!');
          app.infiniteScroll.destroy('.infinite-scroll-orders');
          $$('.infinite-scroll-preloader').remove();
        }

        wait = false;
      });
    }
  );
});

var templateOrders = $$('#templateOrders').html();
var compiledTemplateOrders = Template7.compile(templateOrders);

var tmpOrder = $$('#templateOrder').html();
var compiledTmpOrder = Template7.compile(tmpOrder);
//** END Бесконечный скролл на заказах ***************************


// Кастомная кнопка Назад.
$$(document).on('click', '.my-back', function (e) {
  e.preventDefault();
  mainView.router.back();
});

// Откроем модаль чтобы посмотреть отчёт
$$(document).on('click', '[data-order-uid]', function (e) {
  var html = $$(this).find('.orderListContent').html();
  $$('#my-orders-popup .orderList').html(html);
  app.popup.open('#my-orders-popup');
});

// Обновим модаль
$$(document).on('click', '.button-update-order', function (e) {
  e.preventDefault();
  var uid = $$(this).data('uid');
  mainView.router.navigate('/update_order/'+ uid +'/');
});