routes = [
  {
    path: '/',
    url: './index.html'
  },
  {
    path: '/oferta/',
    url: './pages/oferta.html'
  },
  {
    path: '/example/',
    url: './pages/example.html'
  },
  {
    path: '/how/',
    url: './pages/how.html'
  },
    {
    path: '/contacts/',
    url: './pages/contacts.html'
  },
  {
    path: '/contacts_send/',
    async: function (routeTo, routeFrom, resolve, reject) {
      if( ! isConnect()) { reject(); return; }

      app.preloader.show();

      var
        data = app.utils.extend({
          name: $$('#name').val(),
          email: $$('#email').val(),
          msg: $$('#msg').val()
        }, appData)
      ;

      app.request.post(domain + '/app/contacts_send', data,
        function (data, status, xr) {
          processResponse(data, 'Ошибка при отправке', reject, function(res) {
            reject();
            app.dialog.alert('Ваше сообщение успешно отправлено', 'Внимание!');
            $$('#msg').val('');
          });
        }
      );
    }
  },
  {
    path: '/report/',
    async: function (routeTo, routeFrom, resolve, reject) {
      if( ! isConnect()) { reject(); return; }

      app.preloader.show();

      var
        search_type = $$('.button-select.active').data('select'),
        search = encodeURIComponent($$('#my-main-input').val())
      ;

      app.request.post(domain +'/app/check/'+ search_type +'/'+ search, appData,
        function (data, status, xr) {

          processResponse(data, 'При проверке возникла ошибка', reject, function(res) {
            resolve(
              {templateUrl: './pages/report.html'},
              {context: {data: res.result}}
            );
          });
        }
      );
    }
  },
  {
    path: '/update_order/:uid/',
    async: function (routeTo, routeFrom, resolve, reject) {
      if( ! isConnect()) { reject(); return; }

      app.preloader.show();

      var
        uid = routeTo.params.uid,
        data = app.utils.extend({uid: uid}, appData)
      ;

      app.request.post(domain + '/app/order/update', data,
        function (data, status, xr) {
          processResponse(data, 'Ошибка обновления', reject, function(res) {
            reject();

            if(res.result.order.data) {
              var orderHtml = compiledTmpOrder(res.result.order);
              $$('#my-orders-popup .orderList').html(orderHtml);
              $$('.item-content[data-order-uid="'+ uid +'"] .orderListContent').html(orderHtml);
            }

            app.dialog.alert(res.result.order.order_status, 'Статус заказа', function() {
              if(res.result.order.status == 40) {
                app.popup.close('#my-orders-popup');
                // $$('.my-orders-reload').trigger('click');
                mainView.router.refreshPage();
              }
            });
          });
        }
      );
    }
  },
  {
    path: '/orders/',
    async: function (routeTo, routeFrom, resolve, reject) {
      if( ! isConnect()) { reject(); return; }

      app.preloader.show();

      app.request.post(domain + '/app/orders', appData,
        function (data, status, xr) {
          processResponse(data, 'Ошибка заказов', reject, function(res) {
            if(res.result.orders) {
              for(var i = 0; i < res.result.orders.length; i += 1) {
                var order = res.result.orders[i];
                res.result.orders[i].list = compiledTmpOrder(order);
              }
            }

            resolve(
              {templateUrl: './pages/orders.html'},
              {
                context: {data: res.result},
                on: {
                  pageAfterIn: function (event, page) {
                    if ($$('.ordersList li.my-item-list').length >= res.result.max_items) {
                      app.infiniteScroll.destroy('.infinite-scroll-orders');
                      $$('.infinite-scroll-preloader').remove();
                    }
                  }
                }
              }
            );
          });
        }
      );
    }
  },
  {
    path: '/pay/:shop/:method/:uid/',
    async: function (routeTo, routeFrom, resolve, reject) {
      if( ! isConnect()) { reject(); return; }

      app.preloader.show();

      var
        uid = routeTo.params.uid,
        shop = routeTo.params.shop,
        method = routeTo.params.method,
        data = app.utils.extend({uid: uid, shop: shop, method: method}, appData)
      ;

      reject(); // иначе не срабатывает кнопка back

      app.request.post(domain + '/app/order', data,
        function (data, status, xr) {
          processResponse(data, 'Получить ссылку на оплату не получилось', reject, function(res) {

            browser = cordova.InAppBrowser.open(
              res.result.form.url + "?" + app.utils.serializeObject(res.result.form.fields),
              '_blank',
              'location=no,clearcache=yes,hardwareback=no'
            );

            browser.addEventListener('loadstart', function (event) {
              if(/(payment\/[a-z_]+\/success)|(order\/[a-z0-9]+)/.test(event.url)) {
                browser.close();
                reject();
                mainView.router.navigate('/orders/');
              }
              else if (/payment\/[a-z_]+\/fail/.test(event.url)) {
                browser.close();
                reject();
                app.dialog.alert('Оплата не удалась<br>Попробуйте ещё раз', 'Внимание!');
              }
              else if (/^https?:\/\/xn----7sbgza7acqhge3n\.xn--p1ai\/?$/.test(event.url)) {
                browser.close();
                reject();
              }
            });
          });
        }
      );
    }
  },
  // Default route (404 page). MUST BE THE LAST
  {
    path: '(.*)',
    url: './pages/404.html'
  }
];
